package com.pos.carddemo.test;

import com.basewin.aidl.OnPinInputListener;
import com.basewin.log.LogUtil;
import com.basewin.services.PinpadBinder;
import com.basewin.services.ServiceManager;
import com.basewin.utils.BCDHelper;
import com.pos.carddemo.R;
import com.pos.carddemo.pboc.pinpad.OnGetLayoutSucListener;
import com.pos.carddemo.pboc.pinpad.OnPinDialogListener;
import com.pos.carddemo.pboc.pinpad.PinInputDialog;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.RemoteException;
import android.view.KeyEvent;
import android.view.View;


/**
 * activity for union test only
 * @author liudy
 *
 */
public class TestUnionActivity extends Activity{
	
	//明文
	private static final String protectkey = "11111111111111111111111111111111";
	//密文，明文为全2
	private static final String tmk = "585B9D3F745C8EA95400BD2A3EBDFABF";
	private static final String tmkkcv = "AD9358BA";
	//密文，明文为全3
	private static final String mackey = "D309BE06773E716AD640918E65021B06";
	//mackey校验值
	private static final String mackeykcv = "A43FDDA6";
	
	private static final String encData = "55555555555555555555555555555555";
	
    private final int PIN_DIALOG_SHOW = 1;      //display pinpad(Pinpad弹出)
    private final int PIN_DIALOG_DISMISS = 2;   //close pinpad(Pinpad关闭)
    private final int PIN_SHOW = 3;             //display inputting the pinpad(PIN输入值的显示)
    private final int SETLAYOUT = 4;            //set key layout the pinpad(设置keys布局)
    private final int GETLAYOUT = 5;            //get key layout the pinpad(获取keys布局)
    private PinInputDialog pindialog = null;
    private byte[] keylayout = new byte[96];
    //pinpad the callback(pinpad的回调)
    private OnPinInputListener pinpadListener = new OnPinInputListener() {

        @Override
        public void onInput(int len, int key) throws RemoteException {
            //returns the pinpad the length of the input, the key is invalid(返回pinpad输入中的长度，Key无效)
            LogUtil.e(getClass(),"Pinpad password length in the display:" + len);
            Message message = new Message();
            message.what = PIN_SHOW;
            Bundle bundle = new Bundle();
            bundle.putInt("len", len);
            bundle.putInt("key", key);
            message.setData(bundle);
            pinpad_model.sendMessage(message);
        }

        @Override
        public void onError(int errorCode) throws RemoteException {
            //pinpad result to error(pinpad出错)
        	LogUtil.e(getClass(),"Pinpad error code:" + errorCode);
            pinpad_model.sendEmptyMessage(PIN_DIALOG_DISMISS);
        }

        @Override
        public void onConfirm(byte[] data, boolean isNonePin) {
            //the user to identify the input password,this Data is cryptography encrypted to the password(用户确定了输入的密码,Data为加密了的密码密文)
            if (!isNonePin) {
                //Encrypted transaction(加密交易)
            	LogUtil.e(getClass(),"Pinpad enter password over,encrypt data:" + BCDHelper.hex2DebugHexString(data, data.length));
                pinpad_model.sendEmptyMessage(PIN_DIALOG_DISMISS);
            } else {
                //no secret trading(无密交易)
            	LogUtil.e(getClass(),"Pinpad not encrypt transaction");
                pinpad_model.sendEmptyMessage(PIN_DIALOG_DISMISS);
            }

        }

        @Override
        public void onCancel() throws RemoteException {
            //if you click on the cancel button(点了取消按钮)
        	LogUtil.e(getClass(),"Pinpad User cancel");
            pinpad_model.sendEmptyMessage(PIN_DIALOG_DISMISS);
        }

        @Override
        public void onPinpadShow(byte[] data) throws RemoteException {
            //result Key values,use this on setting the pinpad layout(从底层返回键值，使用此去设置密码键盘)
        	LogUtil.e(getClass(),"Pinpad data is enter password coordinate values");
            Message message = new Message();
            message.what = SETLAYOUT;
            message.obj = data;
            pinpad_model.sendMessage(message);
        }
    };

    //pinpad process control(pinpad流程控制)
    private Handler pinpad_model = new Handler() {
        @Override
        public void handleMessage(Message msg) {

            switch (msg.what) {
                case PIN_DIALOG_SHOW:
                    //display pinpad(显示pinpad)
                	LogUtil.e(getClass(),"Pinpad show");
                    try {
                        //set the pinpad display mode(设置pinpad显示模式)
                        ServiceManager.getInstence().getPinpad().setPinpadMode(PinpadBinder.MODE_RANDOM);
                    } catch (Exception e1) {
                        e1.printStackTrace();
                    }

                    //Pinpad parameter settings[context,card no,tips,amount,callback](pinpad参数设置[上下文,卡号,提示,金额,回调])
                    pindialog = new PinInputDialog(TestUnionActivity.this, "6225882134912085", "Please enter the Bank card password", "0.01", new OnPinDialogListener() {

                        @Override
                        public void OnPinInput(int result) {

                        }

                        @Override
                        public void OnCreateOver() {
                        	LogUtil.e(getClass(),"Pinpad View create success");
                            pinpad_model.sendEmptyMessage(GETLAYOUT);
                        }
                    });

                    break;

                case PIN_DIALOG_DISMISS:
                    //close pinpad(关闭pinpad)
                	LogUtil.e(getClass(),"Pinpad Close");
                    if (pindialog != null) {
                        pindialog.dismiss();
                        pindialog = null;
                    }
                    break;
                case PIN_SHOW:
                    //according to the length of the input password(显示输入的密码长度)
                	LogUtil.e(getClass(),"Pinpad display password length");
                    if (pindialog != null) {
                        Bundle bundle = msg.getData();
                        pindialog.setPins(bundle.getInt("len"), bundle.getInt("key"));
                    }
                    break;
                case SETLAYOUT:
                    //set layout(设置布局)
                	LogUtil.e(getClass(),"Pinpad start set view" + BCDHelper.bcdToString((byte[]) msg.obj, 0, ((byte[]) msg.obj).length));
                    pindialog.setKeyShow((byte[]) msg.obj, new OnGetLayoutSucListener() {
                        @Override
                        public void onSuc() {
                            keylayout = pindialog.getKeyLayout();
                            LogUtil.e(getClass(),"Pinpad start setting view:" + BCDHelper.bcdToString(keylayout, 0, keylayout.length));
                            try {
                                ServiceManager.getInstence().getPinpad().setPinpadLayout(keylayout);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });

                    break;
                case GETLAYOUT:
                    //get layout(获取布局)
                    try {
                        ServiceManager.getInstence().getPinpad().setOnPinInputListener(pinpadListener);
                        //set the pinpad information[key index,card no,password length](设置pinpad相关信息)
                        ServiceManager.getInstence().getPinpad().inputOnlinePinSM4ByArea(1, 1, "6225882134912085", new byte[]{0,6});
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    break;
            }
        }

    };
    
	protected void onCreate(android.os.Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_test);
	};
	
	/**
	 * for test
	 * @param view
	 */
	public void test(View view)
	{
		boolean ret = false;
		try {
//			ret = ServiceManager.getInstence().getPinpad().loadProtectKeySM4ByArea(1, protectkey);
//			LogUtil.e(getClass(), "loadProtectKeySM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadMainKeyWithKcvSM4ByArea(1, 1, tmk, tmkkcv);
//			LogUtil.e(getClass(), "loadMainKeyWithKcvSM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().format();
//			LogUtil.e(getClass(), "format "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadSnKey("AE1DC3C236142F7B16A7F4CB2CA5BA22");
//			LogUtil.e(getClass(), "loadSnKey "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadMainKeySM4ByArea(1, 1, protectkey);
//			LogUtil.e(getClass(), "loadMainKeySM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().UpdateMainKeySM4ByArea(1, 1, tmk);
//			LogUtil.e(getClass(), "UpdateMainKeySM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadMacKeySM4ByArea(1, 1, mackey, mackeykcv);
//			LogUtil.e(getClass(), "loadMacKeySM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadPinKeySM4ByArea(1, 1, mackey, mackeykcv);
//			LogUtil.e(getClass(), "loadPinKeySM4ByArea "+ret);
//			ret = ServiceManager.getInstence().getPinpad().loadTDKeySM4ByArea(1, 1, mackey, mackeykcv);
//			LogUtil.e(getClass(), "loadTDKeySM4ByArea "+ret);
//			String reString = ServiceManager.getInstence().getPinpad().encryptDataSM4ByArea(1, 1, KeyType.MAC_KEY, encData);
//			LogUtil.e(getClass(), "encryptDataSM4ByArea "+reString);
//			String retrackString = ServiceManager.getInstence().getPinpad().encryptDataSM4ByArea(1, 1, KeyType.TRACK_KEY, encData);
//			LogUtil.e(getClass(), "encryptDataSM4ByArea "+retrackString);
//			String repinString = ServiceManager.getInstence().getPinpad().encryptDataSM4ByArea(1, 1, KeyType.PIN_KEY, encData);
//			LogUtil.e(getClass(), "encryptDataSM4ByArea "+repinString);
//			String restrack = ServiceManager.getInstence().getPinpad().encryptMagTrackSM4ByArea(1, 1, "1234567890123456789＝0508201781999168302");
//			LogUtil.e(getClass(), "encryptMagTrackSM4ByArea "+restrack);
//			String restrack3 = ServiceManager.getInstence().getPinpad().encryptMagTrackSM4ByArea(1, 1, "991234567890123456789=156000000000000000000378199921600000508000000000000000000000=000000000003=0000000000");
//			LogUtil.e(getClass(), "encryptMagTrackSM4ByArea "+restrack3);
//			String macdata = ServiceManager.getInstence().getPinpad().calcMACSM4ByArea(1, 1, "1234567890123456789012345678901234567890", BwPinpadSource.MAC_MOD919);
//			LogUtil.e(getClass(), "calcMACSM4ByArea "+macdata);
			
//			pinpad_model.sendEmptyMessage(PIN_DIALOG_SHOW);
			
			String Sn = "00001504"+ServiceManager.getInstence().getDeviceinfo().getSN();
			String encSn = ServiceManager.getInstence().getPinpad().getEncryptedUniqueCode(Sn, "123456");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		LogUtil.e(getClass(), "onKeyDown [keyCode]"+keyCode);
		return super.onKeyDown(keyCode, event);
	}
}
